# VRTheWorldTerrainProvider

#### new Cesium.VRTheWorldTerrainProvider(options)
engine/Source/Core/VRTheWorldTerrainProvider.js 156

To construct a VRTheWorldTerrainProvider, call `VRTheWorldTerrainProvider.fromUrl`. Do not call the constructor directly.
A `TerrainProvider` that produces terrain geometry by tessellating height maps retrieved from a VT MÄK VR-TheWorld server.

Name | Type | Description
--- | --- | ---
`options` | VRTheWorldTerrainProvider.ConstructorOptions | optional An object describing initialization options.

##### Example:

    const terrainProvider = await Cesium.VRTheWorldTerrainProvider.fromUrl(
      "https://www.vr-theworld.com/vr-theworld/tiles1.0.0/73/"
    );
    viewer.terrainProvider = terrainProvider;

##### See:

- TerrainProvider

### Members

#### readonly availability : TileAvailability
engine/Source/Core/VRTheWorldTerrainProvider.js 255

Gets an object that can be used to determine availability of terrain from this provider, such as at points and in rectangles. This property may be undefined if availability information is not available.

#### readonly credit : Credit
engine/Source/Core/VRTheWorldTerrainProvider.js 204

Gets the credit to display when this terrain provider is active. Typically this is used to credit the source of the terrain.

#### readonly errorEvent : Event
engine/Source/Core/VRTheWorldTerrainProvider.js 191

Gets an event that is raised when the terrain provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonly hasVertexNormals : boolean
engine/Source/Core/VRTheWorldTerrainProvider.js 242

Gets a value indicating whether or not the requested tiles include vertex normals.

#### readonly hasWaterMask : boolean
engine/Source/Core/VRTheWorldTerrainProvider.js 230

Gets a value indicating whether or not the provider includes a water mask. The water mask indicates which areas of the globe are water rather than land, so they can be rendered as a reflective surface with animated waves.

#### readonly tilingScheme : GeographicTilingScheme
engine/Source/Core/VRTheWorldTerrainProvider.js 216

Gets the tiling scheme used by this provider.

### Methods

#### static Cesium.VRTheWorldTerrainProvider.fromUrl(url, options) → Promise.<VRTheWorldTerrainProvider>
engine/Source/Core/VRTheWorldTerrainProvider.js 278

Creates a `TerrainProvider` that produces terrain geometry by tessellating height maps retrieved from a VT MÄK VR-TheWorld server.

Name | Type | Description
--- | --- | ---
`url` | Resource | String | The URL of the VR-TheWorld TileMap.
`options` | VRTheWorldTerrainProvider.ConstructorOptions | optional An object describing initialization options.

##### Returns:

##### Throws:

- RuntimeError : metadata specifies and unknown SRS

##### Example:

    const terrainProvider = await Cesium.VRTheWorldTerrainProvider.fromUrl(
      "https://www.vr-theworld.com/vr-theworld/tiles1.0.0/73/"
    );
    viewer.terrainProvider = terrainProvider;

#### getLevelMaximumGeometricError(level) → number
engine/Source/Core/VRTheWorldTerrainProvider.js 348

Gets the maximum geometric error allowed in a tile at a given level.

Name | Type | Description
--- | --- | ---
`level` | number | The tile level for which to get the maximum geometric error.

##### Returns:

The maximum geometric error.

#### getTileDataAvailable(x, y, level) → boolean|undefined
engine/Source/Core/VRTheWorldTerrainProvider.js 437

Determines whether data for a tile is available to be loaded.

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.

##### Returns:

Undefined if not supported, otherwise true or false.

#### loadTileDataAvailability(x, y, level) → undefined|Promise.<void>
engine/Source/Core/VRTheWorldTerrainProvider.js 453

Makes sure we load availability data for a tile

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.

##### Returns:

Undefined if nothing need to be loaded or a Promise that resolves when all required tiles are loaded

#### requestTileGeometry(x, y, level, request) → Promise.<TerrainData>|undefined
engine/Source/Core/VRTheWorldTerrainProvider.js 309

Requests the geometry for a given tile. The result includes terrain data and indicates that all child tiles are available.

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the requested geometry. If this method returns undefined instead of a promise, it is an indication that too many requests are already pending and the request will be retried later.

### Type Definitions

#### Cesium.VRTheWorldTerrainProvider.ConstructorOptions
engine/Source/Core/VRTheWorldTerrainProvider.js 22

Initialization options for the VRTheWorldTerrainProvider constructor

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`ellipsoid` | Ellipsoid | <optional> | The ellipsoid. If not specified, the WGS84 ellipsoid is used.
`credit` | Credit | string | <optional> | A credit for the data source, which is displayed on the canvas.

Need help? The fastest way to get answers is from the community and team on the Cesium Forum.